Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.4.3 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire
Class MulticastRouter

    java.lang.Object
      org.jivesoftware.openfire.container.BasicModule
          org.jivesoftware.openfire.MulticastRouter

All Implemented Interfaces:
  Module, ServerFeaturesProvider, IQResultListener

    public class MulticastRouter

extends BasicModule
implements ServerFeaturesProvider, IQResultListener

Router of packets with multiple recipients. Clients may send a single packet with multiple recipients and the server will broadcast the packet to the target receipients. If recipients belong to remote servers, then this server will discover if remote target servers support multicast service. If a remote server supports the multicast service, a single packet will be sent to the remote server. If a remote server doesn't the support multicast processing, the local server sends a copy of the original stanza to each address.

The current implementation will only search up to the first level of nodes of remote servers when trying to find out if remote servers have support for multicast service. It is assumed that it is highly unlikely for servers to have a node in the second or third depth level providing the multicast service. Servers should normally provide this service themselves or at least as a first level node. This is an implementation of JEP-0033: Extended Stanza Addressing

Author:
  Matt Tucker

Constructor Summary
`MulticastRouter()`

Method Summary
`void` | `answerTimeout(String packetId)` Notification method indicating that a predefined time has passed without receiving answer to a previously sent IQ packet.
`Iterator<String>` | `getFeatures()` Returns an Iterator (of String) with the supported features by the server.
`void` | `initialize(XMPPServer server)` Initializes the basic module.
`void` | `receivedAnswer(IQ packet)` Notification method indicating that a previously sent IQ packet has been answered.
`void` | `route(Packet packet)`

Methods inherited from class org.jivesoftware.openfire.container.BasicModule
`destroy, getName, start, stop`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MulticastRouter

    public MulticastRouter()

Method Detail

### route

    public void route(Packet packet)

### receivedAnswer

    public void receivedAnswer(IQ packet)

  Description copied from interface: `IQResultListener`
  Notification method indicating that a previously sent IQ packet has been answered. The received IQ packet might be of type ERROR or RESULT.

  Specified by:
    `receivedAnswer` in interface `IQResultListener`
  Parameters:
    `packet` - the IQ packet answering a previously sent IQ packet.

### answerTimeout

    public void answerTimeout(String packetId)

  Description copied from interface: `IQResultListener`
  Notification method indicating that a predefined time has passed without receiving answer to a previously sent IQ packet.

  Specified by:
    `answerTimeout` in interface `IQResultListener`
  Parameters:
    `packetId` - The packet id of a previously sent IQ packet that wasn't answered.

### getFeatures

    public Iterator<String> getFeatures()

  Description copied from interface: `ServerFeaturesProvider`
  Returns an Iterator (of String) with the supported features by the server. The features to include are the features offered and supported protocols by the SERVER. The idea is that different modules may provide their features that will ultimately be part of the features offered by the server.

  Specified by:
    `getFeatures` in interface `ServerFeaturesProvider`
  Returns:
    an Iterator (of String) with the supported features by the server.

### initialize

    public void initialize(XMPPServer server)

  Description copied from class: `BasicModule`

  Initializes the basic module.

  Inheriting classes that choose to override this method MUST call this initialize() method before accessing BasicModule resources.

  Specified by:
    `initialize` in interface `Module`
  Overrides:
    `initialize` in class `BasicModule`
  Parameters:
    `server` - the server hosting this module.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.4.3 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2007 Jive Software.